package i382;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * <p>Title: Rezervan kancel</p>
 * <p>Description: Rezervan kancel po internetu</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Jan Doleel
 * @version 1.0
 * Main frame of application for viewing reservations
 */

public class ProhlizecFrame extends JFrame {
  ClientDB client = new ClientDB();
  JPanel contentPane;
  BorderLayout borderLayout1 = new BorderLayout();
  JSplitPane jSplitPane1 = new JSplitPane();
  JLabel jLabel1 = new JLabel();
  JTextField jmeno = new JTextField();
  JPanel jPanel1 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel jPanel2 = new JPanel();
  JLabel jLabel2 = new JLabel();
  JLabel oblast = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel misto = new JLabel();
  JLabel jLabel4 = new JLabel();
  JTextArea kontakt = new JTextArea();
  JLabel jLabel5 = new JLabel();
  JLabel vyzvednuti = new JLabel();
  JPanel jPanel3 = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  JSplitPane jSplitPane2 = new JSplitPane();
  JLabel jLabel6 = new JLabel();
  JLabel vysledek = new JLabel();
  JButton najdi = new JButton();
  JLabel jLabel7 = new JLabel();
  FlowLayout flowLayout1 = new FlowLayout();
  JLabel jLabel8 = new JLabel();
  JLabel jLabel9 = new JLabel();
  JLabel kdy = new JLabel();
  TextArea cenik = new TextArea();
  TextArea cena = new TextArea();

  /**
   * Construct the frame - created by JBuilder
   */

  public ProhlizecFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      System.err.println("Error inicializing frame");
      e.printStackTrace();
    }
    // Needed for compatibility
    client.read();
  }

  /**
   * Component initialization - created by JBuilder
   * @throws java.lang.Exception On some error
   */

  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(400, 407));
    this.setTitle("Prohle rezervac");
    this.addWindowListener(new ProhlizecFrame_this_windowAdapter(this));
    jLabel1.setText("Jmno");
    jmeno.setText("");
    jPanel1.setLayout(borderLayout2);
    jLabel2.setText("Oblast:");
    oblast.setPreferredSize(new Dimension(340, 15));
    oblast.setText("");
    jLabel3.setText("Msto:");
    misto.setPreferredSize(new Dimension(340, 15));
    misto.setText("");
    jLabel4.setText("Kontakt:");
    kontakt.setText("");
    kontakt.setColumns(45);
    kontakt.setRows(3);
    jLabel5.setText("Kde vyzvednout:");
    vyzvednuti.setPreferredSize(new Dimension(290, 15));
    vyzvednuti.setText("");
    jLabel6.setText("jLabel6");
    jPanel3.setLayout(borderLayout3);
    jLabel6.setText("Vsledek");
    vysledek.setText("");
    jPanel3.setPreferredSize(new Dimension(52, 100));
    najdi.setText("Najdi");
    najdi.addActionListener(new ProhlizecFrame_najdi_actionAdapter(this));
    jLabel7.setText("Cenk:");
    jPanel2.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.CENTER);
    jLabel8.setText("Seznam:");
    jLabel9.setText("Kdy se kon:");
    kdy.setPreferredSize(new Dimension(310, 15));
    kdy.setText("");
    cenik.setText("");
    cena.setColumns(52);
    cena.setRows(3);
    cena.setText("");
    contentPane.add(jSplitPane1,  BorderLayout.NORTH);
    jSplitPane1.add(jLabel1, JSplitPane.LEFT);
    jSplitPane1.add(jmeno, JSplitPane.RIGHT);
    contentPane.add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(jLabel2, null);
    jPanel2.add(oblast, null);
    jPanel2.add(jLabel3, null);
    jPanel2.add(misto, null);
    jPanel2.add(jLabel9, null);
    jPanel2.add(kdy, null);
    jPanel2.add(jLabel4, null);
    jPanel2.add(kontakt, null);
    jPanel2.add(jLabel5, null);
    jPanel2.add(vyzvednuti, null);
    jPanel1.add(jPanel3,  BorderLayout.SOUTH);
    jPanel3.add(jSplitPane2,  BorderLayout.SOUTH);
    jSplitPane2.add(jLabel6, JSplitPane.LEFT);
    jSplitPane2.add(vysledek, JSplitPane.RIGHT);
    jPanel3.add(cenik, BorderLayout.CENTER);
    jPanel1.add(najdi,  BorderLayout.NORTH);
    jPanel2.add(jLabel7, null);
    jSplitPane2.setDividerLocation(50);
    jPanel2.add(cena, null);
    jPanel2.add(jLabel8, null);
  }

  /**
   * Overridden so we can exit when window is closed
   */

  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      client.write("Closing");
      System.exit(0);
    }
  }

  /**
   * Response to clicking on Najdi button
   * Get informations from server
   */

  void najdi_actionPerformed(ActionEvent e) {
    if(jmeno.getText().indexOf("'") != -1) {
      vysledek.setText("Jmno nesm obsahovat znak '");
      return;
    }
    if(jmeno.getText().indexOf("@") != -1) {
      vysledek.setText("Jmno nesm obsahovat znak @");
      return;
    }
    String s = client.provide("Seznam@" + jmeno.getText());
    if(s.equals("Zznam nenalezen")) { // Error
       vysledek.setText("Zznam nenalezen");
       return;
    }
    String[] pole = s.split("@",7);
    oblast.setText(pole[0]);
    misto.setText(pole[1]);
    kdy.setText(pole[2]);
    vyzvednuti.setText(pole[3]);
    kontakt.setText(pole[4]);
    // Get informations about prices and available tickets
    String[] cen = pole[5].split("\n");
    // Get informations about rezervations
    String[] klienti = pole[6].split("\n");
    cena.setText("");
    cenik.setText("");
    for(int i=0; i<cen.length; i++) {
      String[] str = cen[i].split(";");
      if(str[1].equals("x")) {
        str[1] = "Neomezen";
      }
      cena.append(str[0] + "\t jet zbv:" + str[1] + "\n");
    }
    for(int i=0; i<klienti.length; i++) {
      pole = klienti[i].split("%",3);
      if(pole.length == 1) {
        break;
      }
      s = pole[0] + "\t " + pole[1] + "\t " + pole[2] + "\n";
      cenik.append(s);
    }
  }

  /**
   * Closing connection on exit
   */
  void this_windowClosing(WindowEvent e) {
    client.provide("Closing");
  }
}

class ProhlizecFrame_najdi_actionAdapter implements java.awt.event.ActionListener {
  ProhlizecFrame adaptee;

  ProhlizecFrame_najdi_actionAdapter(ProhlizecFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.najdi_actionPerformed(e);
  }
}

class ProhlizecFrame_this_windowAdapter extends java.awt.event.WindowAdapter {
  ProhlizecFrame adaptee;

  ProhlizecFrame_this_windowAdapter(ProhlizecFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void windowClosing(WindowEvent e) {
    adaptee.this_windowClosing(e);
  }
}